C     Subroutines to calculates Probabilities and D criticals

C    FUNCTION to CALCULATE Dcrit  (Indep. Populations)
      subroutine dcprobs(D,FD,dFD)
	parameter(ns=20)
      Common /var/ MG,nsz(ns),sigma,mtype
      COMMON WT(ns),M,XM
      External Probs
	FD = Probs(D)-0.05
      dFD = (Probs(D+0.001)- Probs(D-0.001))/0.002
      return
	end

C    FUNCTION to CALCULATE Dcrit (Identical Populations)
      subroutine dcprobsid(D,FD,dFD)
	parameter(ns=20)
      Common /var/ MG,nsz(ns),sigma
      COMMON WT(ns),M,XM
	External Probsid
	FD = Probsid(D)-0.05
      dFD = (Probsid(D+0.001)- Probsid(D-0.001))/0.002
      return
	end


C ROUTINES TO CALCULATE D STATISTIC FOR DIFFERENT CASES

C Calculation of the Probability Function (Indep. Populations)
      Function  Probs(D)
	parameter(ns=20)
      DIMENSION ALAM(10),VA(10),XVA(10)
	DIMENSION VALAM(10),ALAMD(10),PROB(10),ad(10)
	DIMENSION XNE(10)
      Common /var/ MG,nsz(ns),sigma
      COMMON WT(ns),M,XM

      XN=0.
      Do j=1,m
	 XN=XN + real(nsz(j))
	enddo         
      Do j=1,m
        rkj = real(nsz(j))
	if(wt(j).ne.0.)then
          vmul = 1. 
          do k=1,m
	       vmul = vmul * (1.-wt(k))
	    enddo
          if(vmul.eq.0)then
	       VA(j) = wt(j)*XM
	    else
             VA(j) = wt(j)*sqrt(vmul/(1.-wt(j)))*XM
	    endif

	    XVA(j) = real(nsz(j))*VA(j)/(real(nsz(j))+VA(j))
		if(XVA(j).lt.0.or.XVA(j).gt.1.e20)then
		   print *,'Something wrong'
		endif	
	    ALAM(j) = (sqrt(XVA(j)) + 0.12 + 0.11/sqrt(XVA(j)))/wt(j)	 
	else
	   alam(j)=1.e10
	endif
	enddo

	Probs = 1.
	do k=1,m
	  if(alam(k).ge.0.9e10)then
	    prob(k)=1.
	  else
	    alamd(k) = D*alam(k)
          Prob(k) = 1.- probks(alamd(k))
	  endif
	    Probs = Probs*Prob(k)
	enddo
        Probs = 1.-Probs
      return
      end



C Calculation of the Probability Function (Identical Populations)
      Function  Probsid(D)
	parameter(ns=20)
      DIMENSION ALAM(10),VA(10),XVA(10)
	DIMENSION VALAM(10),ALAMD(10),PROB(10),ad(10)
	DIMENSION XNE(10)
      Common /var/ MG,nsz(ns),sigma
      COMMON WT(ns),M,XM

2      Do j=1,m
        rkj = real(nsz(j))
	if(wt(j).gt.0)then
        ad(j) = (sqrt(rkj) + 0.12 + 0.11/sqrt(rkj))/wt(j)
	  XNe(j) = ((ad(j) - 0.12 + sqrt((ad(j)-0.12)**2-4*0.11))/2)**2
	else
	  XNe(j)= -1
	endif
	enddo
	Xneff = 0.
	do j=1,m
	  if(XNe(j).gt.0)Xneff = Xneff + 1./XNe(j)
	enddo 
      Xneff = 1./Xneff
	Xneff2 = Xneff*XM/(Xneff+XM)
      alam1 = (sqrt(Xneff2) + 0.12 + 0.11/sqrt(Xneff2))      
	Probsid = probks(alam1*D) 
      return
      end
	


      FUNCTION rtsafe(funcd,x1,x2,xacc)
      INTEGER MAXIT
      REAL rtsafe,x1,x2,xacc
      EXTERNAL funcd
      PARAMETER (MAXIT=100)
      INTEGER j
      REAL df,dx,dxold,f,fh,fl,temp,xh,xl
      call funcd(x1,fl,df)
      call funcd(x2,fh,df)
      if((fl.gt.0..and.fh.gt.0.).or.(fl.lt.0..and.fh.lt.0.))pause
     *'root must be bracketed in rtsafe'
      if(fl.eq.0.)then
        rtsafe=x1
        return
      else if(fh.eq.0.)then
        rtsafe=x2
        return
      else if(fl.lt.0.)then
        xl=x1
        xh=x2
      else

        xh=x1
        xl=x2
      endif
      rtsafe=.5*(x1+x2)
      dxold=abs(x2-x1)
      dx=dxold
      call funcd(rtsafe,f,df)
      do 11 j=1,MAXIT
        if(((rtsafe-xh)*df-f)*((rtsafe-xl)*df-f).ge.0..or. abs(2.*
     *f).gt.abs(dxold*df) ) then
          dxold=dx
          dx=0.5*(xh-xl)
          rtsafe=xl+dx
          if(xl.eq.rtsafe)return
        else
          dxold=dx
          dx=f/df
          temp=rtsafe
          rtsafe=rtsafe-dx
          if(temp.eq.rtsafe)return

        endif
        if(abs(dx).lt.xacc) return
        call funcd(rtsafe,f,df)
        if(f.lt.0.) then
          xl=rtsafe
        else
          xh=rtsafe
        endif
11    continue
      pause 'rtsafe exceeding maximum iterations'
      return
      END