C  PROGRAM TO CALCULATE THE GENERALIZED KS (FROM PROB. DENS. FUNC)
C  INPUT FILES ARE RAW DATA, (age, error).  NAME TAIL IS .dis
C  OUTPUT 3 cols PDF FILE, TAIL .txt, (age, pdf, cpdf)
c  OUTPUT  GenKs.dat file: D,PROB, etc. 
C  NOTE: If you are building a Composite sample,You need the '*.dis' input files of all the individual components

      subroutine sub_genks(defname,sname,nsp)
	PARAMETER(nts=4000,NPTS=16500,xcrit=1.3581,nsamp=100,ns=20)
	EXTERNAL FDCRIT
      common xlmd(nsamp),mxl,Det
	dimension  xdev(npts),ydev0(npts),ydev(npts),gd(npts),gd0(npts)
	dimension  data1(nts),data2(nts),cros(2*npts),sig(nts)
      Common /var/ MG,nsz(ns),sigma,mtype
      character*9  tab1,sname(nsp)*10,defname*10,yes*1
c	tab1=char(09)
      tab1="       "
	sigma = 0.
	ntavg=0

      xmin = 0.
	xmax = 4000.
      call gprob(MG,defname,data1,sig,avgsig)
	sigma = sigma + avgsig	
	kn=name(defname) 
      open(unit=10,file=defname(1:kn)//'.txt',status='old')
	open(unit=22,file='GenKS.dat')
      nc=1
      n1=1 
10    read(10,*,ERR=12,END=12)xdev(n1),gd(n1),ydev0(n1)
      ydev0(n1)=ydev0(n1)/100.
	n1=n1+1 
      goto 10
12    ydev0(n1)=1.
	close(10)
        
	write(22,*)tab1,tab1,tab1,'CPDF Data',tab1,'   CDF Data'
      write(22,115)'Name',tab1,'Size',tab1,'Dcrit',tab1,'D',tab1,   
     *'PROB',tab1,'D',tab1,'PROB',tab1,'CC'
      write(22,110)defname,MG

115   format(A6,a3,A6,a1,A5,a1,A4,a8,A4,a4,A5,a3,A8,a6,A2)
110   format(A10,I4,a2,f5.3,a2,f5.3,a2,g12.4,
     *a2,f5.3,a2,g10.4,a2,g10.4)

      do jnsp=1,nsp
        call gprob(nsz(jnsp),sname(jnsp),data2,sig,avgsig)
	  sigma = sigma + avgsig
	  call kstwo(data1,MG,data2,nsz(jnsp),d0,prob0)	  
	  kn=name(sname(jnsp)) 
c	  print *,sname(jnsp)(1:kn)
        open(unit=12,file=sname(jnsp)(1:kn)//'.txt',status='old')
        n2=1
14      read(12,*,ERR=16,END=16)xd,gd0(n2),ydev(n2)
        ydev(n2) = ydev(n2)/100.
	  n2=n2+1
        goto 14
16      ydev(n2)=1.
	  close(12)
        if(n1.ne.n2)stop 'PDF sampling Incorrect'         
        call correl(gd0,gd,n2-2,cros)
	  cc = cros(1)
        call correl(gd0,gd0,n2-2,cros)
	  cc1 = cros(1)
        call correl(gd,gd,n2-2,cros)
	  cc2 = cros(1)
	  cc = cc/sqrt(cc1*cc2)
        D = 0.
        do j = 1,n2
	    DN = abs(ydev0(j)-ydev(j))	
          if(DN.gt.D)then
	     D=DN
	     Jm = j
	    endif
        enddo
  	  en =sqrt(real(MG*nsz(jnsp))/real(MG+nsz(jnsp)))
	  XN = en+0.12+0.11/en
	  PROBKN=PROBKS(XN*D)
	  Dcrit = xcrit/XN
        write(22,110)sname(jnsp),nsz(jnsp),tab1,Dcrit,tab1,D,tab1,PROBKN
     *,tab1,d0,tab1,Prob0,tab1,cc

	enddo
	
 18   sigma = sigma/real(nsp+1)*100.
      print *,'Total Average % sigma= ',sigma
      
	RETURN

100   format(2g20.8)
120   format(101g20.8)
      END


      function name(sname)  
      character sname*10  
      do 10 j=1,10  
        if(sname(j:j).eq.' ')then  
          if(j.eq.1)stop 'name starts with empty space'  
          name = j-1  
          return  
        endif  
        name = 10  
10    continue  
      return  
      end  

	function fdcrit(D)
	PARAMETER (nsamp=100)
      common xlmd(nsamp),mxl,Det
	fdcrit = PNover(xlmd,mxl,D)-0.05
	return
	end	