C    PROB_TERN_CONTOUR
C    CALCULATES CONTOURS ON A PROB TERNARY PLOT OF (JL,JM,JN)
      subroutine sub_contour(snamatx,nsp,mans)
	PARAMETER(NG=1000,NN=100,NPS=16500,eps=5e-5,ns=20)
	dimension dcrit(0:ng,0:ng),probks(0:ng,0:ng)
	dimension aux1(ng*100),aux2(ng*100)
	dimension xwrt(20),xdsolv(NG*100,2),xaux(20,NG*100,2),AAux(300)
	dimension xdev(nps),gd0(nps),ydev0(nps),gd1(nps),ydev1(nps)
      common /arrays/ DATA1(0:ns,nps),xmat(0:ng,0:ng),pxmatin(0:ng,0:ng)
     *,pxmatid(0:ng,0:ng),eroid(0:ng,0:ng),eroin(0:ng,0:ng)
      Common /var/ MG,nsz(ns),sigma,mtype
	common /bord/ AL(NN),BL(NN),CL(NN),AB(3),ka(3)
      character*9  tab1,snamatx*10,yes*1,typ*7
      xsig = -1.
	kn=name(snamatx) 
	if(mans.eq.1.and.mtype.eq.1)then
	  typ='_probin'
	  call swapmtx(xmat,pxmatin,ng)
	elseif(mans.eq.1.and.mtype.eq.2)then
	  typ='_probid'
	  call swapmtx(xmat,pxmatid,ng)
	elseif(mans.eq.2.and.mtype.eq.1)then
        typ='_erosin'
	  call swapmtx(xmat,eroin,ng)
	elseif(mans.eq.2.and.mtype.eq.2)then
	  typ='_erosid'
	  call swapmtx(xmat,eroid,ng)
	endif
	open(unit=25,file=snamatx(1:kn)//typ//'_cont.dat')
	open(unit=26,file=snamatx(1:kn)//'_param.dat',access='APPEND')
	WRITE(26,*)
	WRITE(26,*)'CONTOUR SUBROUTINE'
	WRITE(26,*)
      dng = 100./ng
      xf = 0.01*dng
	nmin = 1
	diffmax = -1.d10


 	Pmin = 10.
	Pmax = 0.
	Dem = 1.
      do jl=0,NG
	   do jm=0,NG-jl
	     if(xmat(jl,jm).lt.Pmin)Pmin=xmat(jl,jm)
           if(xmat(jl,jm).gt.Pmax)then
		    Pmax=xmat(jl,jm)
              jlmax = jl
	        jmmax = jm
	     endif
	   enddo
      enddo

 	write(26,*)'Pmax contr:',jlmax*0.1,jmmax*0.1,100.-(jlmax+jmmax)*0.1     

      if(Pmin.eq.Pmax)goto 80
      Plow=0.05
	if(Plow.gt.Pmax)Plow=Pmax
	NL = (Pmax - Plow)/Plow + 1.
	write(26,*)'Plow= ',Plow,'   Pmax= ',Pmax,' N=',NL
	
	do jd=1,NL+3
	  if(jd.le.NL)then
	   D = Plow + Plow * (jd -1)
         write(26,*)D
	  else
	   D=10.**(NL-jd-1)
	  endif
	  kloop = 0
	  k = 1
	  AB(1) =  D - xmat(NG,0)
        AB(2) =  D - xmat(0,NG)
	  AB(3) =  D - xmat(0,0)
        call border(D,xmat)
	  kt = ka(1) + ka(2) + ka(3)
    	
C  LOOP 1: HORIZONTAL RASTER
       do jl=0,NG
	   do jm=0,NG-jl-1
	    XD = (D-xmat(jl,jm))*(D-xmat(jl,jm+1))
	   if(XD.le.0.)then
	      if(xmat(jl,jm+1)-xmat(jl,jm).ne.0)then
	        xjm=jm + (D-xmat(jl,jm))/(xmat(jl,jm+1)-xmat(jl,jm))
	      else
	        xl=jm
	      endif
            xdsolv(k,1) = jl
	      xdsolv(k,2) = xjm
	      k=k+1
	   endif
	   enddo
       enddo
C  LOOP 2: VERTICAL RASTER
       do jm=0,NG
	   do jl=0,NG-jm-1
	     XD = (D-xmat(jl,jm))*(D-xmat(jl+1,jm))
	   if(XD.le.0.)then
	      if(xmat(jl+1,jm)-xmat(jl,jm).ne.0)then
	       xjl=jl + (D-xmat(jl,jm))/(xmat(jl+1,jm)-xmat(jl,jm))
	      else
	       xjl = jl
	      endif
             xdsolv(k,1) = xjl
	       xdsolv(k,2) = jm
	      k = k + 1
	   endif
	   enddo
       enddo

C     Adding border points if they were not found during Loop 1 and 2
       if(kt.gt.0)then
         do j=1,ka(1)
	    kflag = 0
          do jk=1,k-1
	      if(xdsolv(jk,1).eq.0.and.xdsolv(jk,2).eq.AL(j))kflag = 1
	    enddo
	    if(kflag.eq.0)then
		  xdsolv(k,1)=0.
		  xdsolv(k,2)=AL(j)
		  k = k+1
		endif
	   enddo     
         do j=1,ka(2)
	    kflag = 0
          do jk=1,k-1
	      if(xdsolv(jk,1).eq.BL(j).and.xdsolv(jk,2).lt.eps)kflag = 1
	    enddo
	    if(kflag.eq.0)then
		  xdsolv(k,1)=BL(j)
		  xdsolv(k,2)=0.
		  k = k+1
		endif
	   enddo     
         do j=1,ka(3)
	    kflag = 0
          do jk=1,k-1
	     if(xdsolv(jk,1).eq.CL(j).and.xdsolv(jk,2).eq.NG-CL(j))kflag=1
	    enddo
	    if(kflag.eq.0)then
		  xdsolv(k,1)=CL(j)
		  xdsolv(k,2)=real(NG)-CL(j)
		  k = k+1
		endif
	  enddo     
       endif
C       Adding corner point if xmat < D  Note:only incresing k is important
       do j=1,3
         if(AB(j).gt.0)then
		  xdsolv(k,1)=-10
		  xdsolv(k,2)=-10
		  k = k+1
	   endif
	 enddo
C    Cleaning Contours by removing equal points.
       sl=1
       do jk=1,k-1
	   do j0=jk+1,k-1
	  if(xdsolv(jk,1).ne.-10)then
	     xds1= abs(xdsolv(jk,1)-xdsolv(j0,1))
	     xds2=abs(xdsolv(jk,2)-xdsolv(j0,2))
	     if(xds1+xds2.eq.0)then
	        xdsolv(j0,1)=-10
	        xdsolv(j0,2)=-10
	        sl=sl+1
	     endif
	  endif
          enddo
	 enddo   
       Do jk=1,k-1
		aux1(jk)=xdsolv(jk,1)
	    aux2(jk)=xdsolv(jk,2)
	 enddo
       call sort2(k-1,aux1,aux2)
       sk=0
       do jk=1,k-1
	  if(aux1(jk).eq.-10)sk= sk+1
       enddo	    
       do jk=1,k-1
         xdsolv(jk,1)=aux1(sk+jk)
	   xdsolv(jk,2)=aux2(sk+jk)
	 enddo	     
       k=k-sk

C     Ordering the Contours
       l = 1
C   Start from a border if loop ends on borders
       if(kt.gt.0)then
        if(ka(1).gt.0)then 
          do jk=1,k-1
	      if(xdsolv(jk,1).eq.0.and.xdsolv(jk,2).eq.AL(1))then
		     kstart = jk
		     xaux(jd,l,1) = xdsolv(kstart,1)
	         xaux(jd,l,2) = xdsolv(kstart,2)
               xdsolv(kstart,1)= -10
	         xdsolv(kstart,2)= -10
	         ka(1) = ka(1) -1
	         goto 10
	      endif
	    enddo
	  elseif(ka(2).gt.0)then
          do jk=1,k-1
	      if(xdsolv(jk,1).eq.BL(1).and.xdsolv(jk,2).eq.0)then
		     kstart = jk
		     xaux(jd,l,1) = xdsolv(kstart,1)
	         xaux(jd,l,2) = xdsolv(kstart,2)
               xdsolv(kstart,1)= -10
	         xdsolv(kstart,2)= -10
	         ka(2) = ka(2) -1
	         goto 10
	      endif
	    enddo
	  else
          do jk=1,k-1
	       xa1 = abs(xdsolv(jk,1)-CL(1))
	       xa2 = abs(xdsolv(jk,2)+xdsolv(jk,1)-real(NG))
	      if(xa1.lt.eps.and.xa2.lt.eps)then
		     kstart = jk
		     xaux(jd,l,1) = xdsolv(kstart,1)
	         xaux(jd,l,2) = xdsolv(kstart,2)
               xdsolv(kstart,1)= -10
	         xdsolv(kstart,2)= -10
	         ka(3) = ka(3) - 1
	         goto 10
	      endif
	    enddo
        endif	   
	 endif
1	 continue 


C    Start from any point if loop is closed.
         do jk=1,k-1
	      if(xdsolv(jk,1).ne.-10.)then
		     kstart = jk
		     xaux(jd,l,1) = xdsolv(kstart,1)
	         xaux(jd,l,2) = xdsolv(kstart,2)
               xdsolv(kstart,1)= -10
	         xdsolv(kstart,2)= -10
	         goto 10
	      endif
	    enddo
     
C  FOLLOWING CONTOUR UNTIL NEXT AXIS OR CLOSE LOOP
10     xdmin = 2.
       xdleast = 1000.
       do n=1,k-1
        arg1 = 	 (xaux(jd,l,1)-xdsolv(n,1))**2  
	  arg2 =   (xaux(jd,l,2)-xdsolv(n,2))**2
	  xd = sqrt(arg1 + arg2)
	  if(xd.lt.xdleast)then
	     xdleast=xd
	     nleast = n
	  endif
	   if(xd.lt.sqrt(2.).and.xd.lt.xdmin)then
	      xdmin= xd
	      nmin = n
         endif
	 enddo
22	 if(xdmin.lt.sqrt(2.))then
	     l = l+1
	     xaux(jd,l,1) = xdsolv(nmin,1)
	     xaux(jd,l,2) = xdsolv(nmin,2)
		 xdc = real(NG) - xdsolv(nmin,1)-xdsolv(nmin,2)
	     xdsolv(nmin,1) = -10
           xdsolv(nmin,2) = -10
	     if(xdc.lt.eps)ka(3)=ka(3)-1
	     if(xaux(jd,l,1).lt.eps)ka(1)=ka(1)-1
	     if(xaux(jd,l,2).lt.eps)ka(2)=ka(2)-1
	     if(l.eq.k-1)goto 20
	     goto 10
	 endif
       if(l.eq.k-1)goto 20
	 l = l+1    
	 kloop = kloop + 1
C     First Check in which Axis it has finished
       xdc = abs(real(NG) - xaux(jd,l-1,1) -xaux(jd,l-1,2))
       if(abs(xaux(jd,l-1,1)).lt.eps)kc=1
       if(abs(xaux(jd,l-1,2)).lt.eps)kc=2
	 if(xdc.lt.eps)kc=3   
	 if(kc.eq.0)then
         l = l - 1
         nmin = nleast
         xdmin = 1.
	   goto 22	
	 endif    
	 ksum = 0
21	 if(ka(kc).gt.0)then
          do jk=1,k-1
	      xdc = abs(NG - xdsolv(jk,1) - xdsolv(jk,2))
	      if(kc.lt.3)xds = abs(xdsolv(jk,kc))
	      if((xds.lt.eps.and.kc.lt.3).or.(xdc.lt.eps.and.kc.eq.3))then
	        xaux(jd,l,1) = xdsolv(jk,1)
	        xaux(jd,l,2) = xdsolv(jk,2)
	        xdsolv(jk,1) = -10
              xdsolv(jk,2) = -10
	        ka(kc) = ka(kc) - 1
	        goto 10
	      endif 
	    enddo
	    ka(kc)= ka(kc) -1
	 else
	   call kcyc(kc)
	   ksum=ksum + 1
	 endif
	 if(ksum.le.3)goto 21	           
         goto 19

C  If no more boundary points, Add the corner points.
C Line to avoid adding corner points
           if(l.le.k-3)then 
	        k=k-3
	        goto 19
	     endif
C Remove to add corner points
       do j=1,3
	    if(AB(j).gt.0)then
            if(j.eq.1)then
	        xaux(jd,l,1) = NG
	        xaux(jd,l,2) = 0.
	        l = l + 1
	      elseif(j.eq.2)then
	        xaux(jd,l,1) = 0.
	        xaux(jd,l,2) = NG
	        l = l + 1
	      else
	        xaux(jd,l,1) = 0.
	        xaux(jd,l,2) = 0.
	        l = l + 1
	      endif
		 endif
	 enddo  
19	  if(l.eq.k)then
	   l = l - 1
		 goto 20
	  endif
	  goto 1
20	 do n=1,l
        do jn=1,NL+3
	      if(jn.eq.jd)then
	         xwrt(jn) = (NG-xaux(jd,n,1)-xaux(jd,n,2))*xf
	      else
	         xwrt(jn) = -1
	      endif
        enddo	 
	  if(n.gt.1)then
          arg1 = xaux(jd,n-1,1)-xaux(jd,n,1)  
	    arg2 = xaux(jd,n-1,2)-xaux(jd,n,2)
	    xd = sqrt(arg1**2 + arg2**2 +(arg1+arg2)**2)
	    if(xd.gt.sqrt(2.))then
	     write(25,110)xaux(jd,n,1)*xf,xsig,
     *     (xwrt(jn),jn=1,NL+3)
	    endif	 
	  endif  
	  write(25,110)xaux(jd,n,1)*xf,xaux(jd,n,2)*xf,
     *(xwrt(jn),jn=1,NL+3)
       enddo
	enddo
100   format(I4,2g20.8)
110   format(50f10.6)
120   format(1x,1001f10.6)
      close(26)
	close(25)
      return
80    Print *,'MAX = MIN value, NO CONTOURS? REVIEW YOUR MATRICES'
      return
      end

      subroutine kcyc(k)
	    k = k + 1
		if(k.gt.3)k=1
		return
	end	         	   

      SUBROUTINE sort2(n,arr,brr)
      INTEGER n,M,NSTACK
      REAL arr(n),brr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,ir,j,jstack,k,l,istack(NSTACK)
      REAL a,b,temp
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 12 j=l+1,ir
          a=arr(j)
          b=brr(j)
          do 11 i=j-1,l,-1
            if(arr(i).le.a)goto 2
            arr(i+1)=arr(i)
            brr(i+1)=brr(i)
11        continue
          i=l-1
2         arr(i+1)=a
          brr(i+1)=b
12      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        temp=arr(k)

        arr(k)=arr(l+1)
        arr(l+1)=temp
        temp=brr(k)
        brr(k)=brr(l+1)
        brr(l+1)=temp
        if(arr(l).gt.arr(ir))then
          temp=arr(l)
          arr(l)=arr(ir)
          arr(ir)=temp
          temp=brr(l)
          brr(l)=brr(ir)
          brr(ir)=temp
        endif
        if(arr(l+1).gt.arr(ir))then
          temp=arr(l+1)
          arr(l+1)=arr(ir)
          arr(ir)=temp
          temp=brr(l+1)
          brr(l+1)=brr(ir)
          brr(ir)=temp
        endif
        if(arr(l).gt.arr(l+1))then
          temp=arr(l)
          arr(l)=arr(l+1)
          arr(l+1)=temp

          temp=brr(l)
          brr(l)=brr(l+1)
          brr(l+1)=temp
        endif
        i=l+1
        j=ir
        a=arr(l+1)
        b=brr(l+1)
3       continue
          i=i+1
        if(arr(i).lt.a)goto 3
4       continue
          j=j-1
        if(arr(j).gt.a)goto 4
        if(j.lt.i)goto 5
        temp=arr(i)
        arr(i)=arr(j)
        arr(j)=temp
        temp=brr(i)
        brr(i)=brr(j)
        brr(j)=temp
        goto 3
5       arr(l+1)=arr(j)
        arr(j)=a
        brr(l+1)=brr(j)
        brr(j)=b

        jstack=jstack+2
        if(jstack.gt.NSTACK)pause 'NSTACK too small in sort2'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END

	subroutine swapmtx(xmat1,xmat2,ng)
	dimension xmat1(0:ng,0:ng),xmat2(0:ng,0:ng)
	do jl=0,NG
	   do jm=0,NG-jl
	      xmat1(jl,jm)=xmat2(jl,jm)
	   enddo
	enddo
	return
	end