      subroutine gprob(N1,sname,data1,sig,avgsig)
	PARAMETER(NTS=4000,EPS=0.1)
	Parameter(ngd=16384,xmin=0.,xmax=4000.)

	DIMENSION DATA1(nts),sig(nts)
      common x0,w
      character*9  tab1,sname*10,yes*1
	idum = -1
	NPG = 100
	kn=name(sname) 
      call readsample(sname,n1,data1,sig,avgsig)
      open(unit=12,file=sname(1:kn)//'.txt')	 
	
      gcum = 0.
	dx =(xmax-xmin)/real(ngd)
    
      do i=1,ngd+1   
         gd0=0.
	   xk = xmin + (i-1)*dx
	   do j=1,n1
	     gd0=gd0 + gdist(xk,data1(j),sig(j))
	   enddo
	   gd0= gd0/n1
	   gcum = gcum + gd0*dx
	   if(gcum.gt.1.)gcum = 1.
	   write(12,*)xk,gd0,gcum*100.
	enddo
      write(12,*)'&  avgsig= ',avgsig*100.
	close(12)
	
      return
	end

      subroutine comp_gprob(xneff,sname,avgsig)
	PARAMETER(NTS=4000,EPS=0.1,nsamp=100,NP=10)
	Parameter(ngd=16384,xmin=0.,xmax=4000.)
	DIMENSION DATAC(nts),DATA1(NTS),sig(nts)

c	EXTERNAL FUNC
      common xlmd(nsamp),mxl,Det
      common x0,w
      character*9  tab1,sname*10,snameaux*10,yes*1
	tab1=char(09)
	idum = -1
	NPG = 100
	avgsig = 0.
      kn=name(sname)
      open(unit=61,file=sname(1:kn)//'_info.txt')
	dx = (xmax-xmin)/ngd
	do i=1,ngd+1
	    datac(i)=0.
	enddo
 
2     print *, 'ADDING SAMPLES TO COMPOSITE DISTRIBUTION'  
	m=1  
	xneff = 0.
	wsum = 0.

      m = 1 
1	print *,'Enter sample name (stop to end reading)'
	read *,snameaux
	if(snameaux(1:4).eq.'stop')goto 18

	print *,'Enter % weight of sample in the composite'
	read  *,wg
      wg = wg/100.
	wsum = wsum + wg

      call gprob(NS,snameaux,data1,sig,avsig)
	avgsig =avgsig + avsig

      xneff = xneff + wg**2/ns    
	xlmd(m)= (sqrt(real(ns)) + 0.12 + 0.11/sqrt(real(ns)))/wg

      write(61,*)snameaux(1:kn),tab1,'N=',ns,tab1,'Weight=',wg

	do i=1,ngd+1
          xk = xmin + (i-1)*dx
	  do j=1,ns
	    datac(i)=datac(i) + wg*gdist(xk,data1(j),sig(j))/ns
	  enddo	
      enddo
	m = m + 1
      goto 1

18    If(abs(wsum-1.0).gt.5.e-5)then
        print *, "Weight error: WSUM not 1" 
	  print *, 'You need to re-enter Composite Sample parameters'
	  goto 2
	endif 
	avgsig = avgsig/real(m-1)
      xneff = 1.d0/xneff
	gcum = 0.


      open(unit=60,file=sname(1:kn)//'.txt')	
      do i=1,ngd+1
        xk = xmin + (i-1)*dx
         gcum = gcum + datac(i)*dx
	   if(gcum.gt.1.)gcum = 1.
	  write(60,*)xk,datac(i),gcum*100.
	enddo
	  write(60,*)"&  Neff= ",nint(xneff),' Avgsig= ',avgsig*100.
	  write(61,*)'Neff=',nint(xneff)
	  close(60)
        close(61)
      return
100   format(A10,a1,a2,I5,a1,a2,g20.8)
	end


	function gdist(x,xval,xerr)
c      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793)
         xd=(x-xval)**2
	   gdist = exp(-xd/2./xerr**2)/xerr/sqrt(2.*pi)
      return
      end      


      function PNover(xl,m,D)
	dimension xl(m)
	PNover = 1.
	do j=1,m
	     PNover = PNover*(1. - PROBKS(xl(j)*D))
	enddo
	PNover = 1. - PNover
	return
	end


      
      FUNCTION rtbis(func,x1,x2,xacc)
      INTEGER JMAX
      REAL rtbis,x1,x2,xacc,func
      EXTERNAL func
      PARAMETER (JMAX=40)
      INTEGER j
      REAL dx,f,fmid,xmid
      fmid=func(x2)
      f=func(x1)
      if(f*fmid.ge.0.) then
	  pause 'root must be bracketed in rtbis'
	endif
      if(f.lt.0.)then
        rtbis=x1
        dx=x2-x1
      else
        rtbis=x2
        dx=x1-x2
      endif
      do 11 j=1,JMAX
        dx=dx*.5
        xmid=rtbis+dx
        fmid=func(xmid)
        if(fmid.le.0.)rtbis=xmid
        if(abs(dx).lt.xacc .or. fmid.eq.0.) return

11    continue
      pause 'too many bisections in rtbis'
      END